/* RygelConfigFile.c generated by valac 0.56.17, the Vala compiler
 * generated from RygelConfigFile.vala, do not modify */

/*
 * Copyright (c) 2011-2015 elementary Developers (https://launchpad.net/elementary)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 */

#include "io.elementary.settings.sharing.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	SHARING_BACKEND_RYGEL_CONFIG_FILE_0_PROPERTY,
	SHARING_BACKEND_RYGEL_CONFIG_FILE_NUM_PROPERTIES
};
static GParamSpec* sharing_backend_rygel_config_file_properties[SHARING_BACKEND_RYGEL_CONFIG_FILE_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_key_file_unref0(var) ((var == NULL) ? NULL : (var = (g_key_file_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _SharingBackendRygelConfigFilePrivate {
	gchar* config_filename;
	GKeyFile* config_file;
	gchar** media_uris;
	gint media_uris_length1;
	gint _media_uris_size_;
};

static gint SharingBackendRygelConfigFile_private_offset;
static gpointer sharing_backend_rygel_config_file_parent_class = NULL;

static void sharing_backend_rygel_config_file_setup_config_file (SharingBackendRygelConfigFile* self);
static GObject * sharing_backend_rygel_config_file_constructor (GType type,
                                                         guint n_construct_properties,
                                                         GObjectConstructParam * construct_properties);
static void sharing_backend_rygel_config_file_finalize (GObject * obj);
static GType sharing_backend_rygel_config_file_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
sharing_backend_rygel_config_file_get_instance_private (SharingBackendRygelConfigFile* self)
{
	return G_STRUCT_MEMBER_P (self, SharingBackendRygelConfigFile_private_offset);
}

gboolean
sharing_backend_rygel_config_file_get_media_type_enabled (SharingBackendRygelConfigFile* self,
                                                          const gchar* media_type_id)
{
	GKeyFile* _tmp0_;
	gboolean _tmp8_ = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 57 "../src/Backend/RygelConfigFile.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 57 "../src/Backend/RygelConfigFile.vala"
	g_return_val_if_fail (media_type_id != NULL, FALSE);
#line 58 "../src/Backend/RygelConfigFile.vala"
	_tmp0_ = self->priv->config_file;
#line 58 "../src/Backend/RygelConfigFile.vala"
	if (_tmp0_ == NULL) {
#line 59 "../src/Backend/RygelConfigFile.vala"
		result = FALSE;
#line 59 "../src/Backend/RygelConfigFile.vala"
		return result;
#line 100 "RygelConfigFile.c"
	}
	{
		gboolean _tmp1_ = FALSE;
		GKeyFile* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gboolean _tmp5_;
#line 63 "../src/Backend/RygelConfigFile.vala"
		_tmp2_ = self->priv->config_file;
#line 63 "../src/Backend/RygelConfigFile.vala"
		_tmp3_ = g_strdup_printf ("share-%s", media_type_id);
#line 63 "../src/Backend/RygelConfigFile.vala"
		_tmp4_ = _tmp3_;
#line 63 "../src/Backend/RygelConfigFile.vala"
		_tmp5_ = g_key_file_get_boolean (_tmp2_, "Tracker", _tmp4_, &_inner_error0_);
#line 63 "../src/Backend/RygelConfigFile.vala"
		_g_free0 (_tmp4_);
#line 63 "../src/Backend/RygelConfigFile.vala"
		_tmp1_ = _tmp5_;
#line 63 "../src/Backend/RygelConfigFile.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 122 "RygelConfigFile.c"
			goto __catch0_g_error;
		}
#line 63 "../src/Backend/RygelConfigFile.vala"
		result = _tmp1_;
#line 63 "../src/Backend/RygelConfigFile.vala"
		return result;
#line 129 "RygelConfigFile.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp6_;
		const gchar* _tmp7_;
#line 62 "../src/Backend/RygelConfigFile.vala"
		e = _inner_error0_;
#line 62 "../src/Backend/RygelConfigFile.vala"
		_inner_error0_ = NULL;
#line 65 "../src/Backend/RygelConfigFile.vala"
		_tmp6_ = e;
#line 65 "../src/Backend/RygelConfigFile.vala"
		_tmp7_ = _tmp6_->message;
#line 65 "../src/Backend/RygelConfigFile.vala"
		g_warning ("RygelConfigFile.vala:65: Reading configuration file failed: %s", _tmp7_);
#line 67 "../src/Backend/RygelConfigFile.vala"
		result = FALSE;
#line 67 "../src/Backend/RygelConfigFile.vala"
		_g_error_free0 (e);
#line 67 "../src/Backend/RygelConfigFile.vala"
		return result;
#line 153 "RygelConfigFile.c"
	}
	__finally0:
#line 62 "../src/Backend/RygelConfigFile.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 62 "../src/Backend/RygelConfigFile.vala"
	g_clear_error (&_inner_error0_);
#line 62 "../src/Backend/RygelConfigFile.vala"
	return _tmp8_;
#line 162 "RygelConfigFile.c"
}

gchar*
sharing_backend_rygel_config_file_get_media_type_folder (SharingBackendRygelConfigFile* self,
                                                         const gchar* media_type_id)
{
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
#line 72 "../src/Backend/RygelConfigFile.vala"
	static GQuark _tmp1_label0 = 0;
#line 72 "../src/Backend/RygelConfigFile.vala"
	static GQuark _tmp1_label1 = 0;
#line 72 "../src/Backend/RygelConfigFile.vala"
	static GQuark _tmp1_label2 = 0;
#line 177 "RygelConfigFile.c"
	gchar* result;
#line 71 "../src/Backend/RygelConfigFile.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 71 "../src/Backend/RygelConfigFile.vala"
	g_return_val_if_fail (media_type_id != NULL, NULL);
#line 72 "../src/Backend/RygelConfigFile.vala"
	_tmp0_ = media_type_id;
#line 72 "../src/Backend/RygelConfigFile.vala"
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
#line 72 "../src/Backend/RygelConfigFile.vala"
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("music")))) {
#line 72 "../src/Backend/RygelConfigFile.vala"
		switch (0) {
#line 191 "RygelConfigFile.c"
			default:
			{
				const gchar* _tmp3_ = NULL;
				gchar** _tmp4_;
				gint _tmp4__length1;
				gchar* _tmp7_;
#line 75 "../src/Backend/RygelConfigFile.vala"
				_tmp4_ = self->priv->media_uris;
#line 75 "../src/Backend/RygelConfigFile.vala"
				_tmp4__length1 = self->priv->media_uris_length1;
#line 75 "../src/Backend/RygelConfigFile.vala"
				if (_tmp4__length1 > 0) {
#line 204 "RygelConfigFile.c"
					gchar** _tmp5_;
					gint _tmp5__length1;
					const gchar* _tmp6_;
#line 75 "../src/Backend/RygelConfigFile.vala"
					_tmp5_ = self->priv->media_uris;
#line 75 "../src/Backend/RygelConfigFile.vala"
					_tmp5__length1 = self->priv->media_uris_length1;
#line 75 "../src/Backend/RygelConfigFile.vala"
					_tmp6_ = _tmp5_[0];
#line 75 "../src/Backend/RygelConfigFile.vala"
					_tmp3_ = _tmp6_;
#line 216 "RygelConfigFile.c"
				} else {
#line 75 "../src/Backend/RygelConfigFile.vala"
					_tmp3_ = "";
#line 220 "RygelConfigFile.c"
				}
#line 75 "../src/Backend/RygelConfigFile.vala"
				_tmp7_ = g_strdup (_tmp3_);
#line 75 "../src/Backend/RygelConfigFile.vala"
				result = _tmp7_;
#line 75 "../src/Backend/RygelConfigFile.vala"
				return result;
#line 228 "RygelConfigFile.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("videos")))) {
#line 72 "../src/Backend/RygelConfigFile.vala"
		switch (0) {
#line 234 "RygelConfigFile.c"
			default:
			{
				const gchar* _tmp8_ = NULL;
				gchar** _tmp9_;
				gint _tmp9__length1;
				gchar* _tmp12_;
#line 79 "../src/Backend/RygelConfigFile.vala"
				_tmp9_ = self->priv->media_uris;
#line 79 "../src/Backend/RygelConfigFile.vala"
				_tmp9__length1 = self->priv->media_uris_length1;
#line 79 "../src/Backend/RygelConfigFile.vala"
				if (_tmp9__length1 > 1) {
#line 247 "RygelConfigFile.c"
					gchar** _tmp10_;
					gint _tmp10__length1;
					const gchar* _tmp11_;
#line 79 "../src/Backend/RygelConfigFile.vala"
					_tmp10_ = self->priv->media_uris;
#line 79 "../src/Backend/RygelConfigFile.vala"
					_tmp10__length1 = self->priv->media_uris_length1;
#line 79 "../src/Backend/RygelConfigFile.vala"
					_tmp11_ = _tmp10_[1];
#line 79 "../src/Backend/RygelConfigFile.vala"
					_tmp8_ = _tmp11_;
#line 259 "RygelConfigFile.c"
				} else {
#line 79 "../src/Backend/RygelConfigFile.vala"
					_tmp8_ = "";
#line 263 "RygelConfigFile.c"
				}
#line 79 "../src/Backend/RygelConfigFile.vala"
				_tmp12_ = g_strdup (_tmp8_);
#line 79 "../src/Backend/RygelConfigFile.vala"
				result = _tmp12_;
#line 79 "../src/Backend/RygelConfigFile.vala"
				return result;
#line 271 "RygelConfigFile.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label2) ? _tmp1_label2 : (_tmp1_label2 = g_quark_from_static_string ("pictures")))) {
#line 72 "../src/Backend/RygelConfigFile.vala"
		switch (0) {
#line 277 "RygelConfigFile.c"
			default:
			{
				const gchar* _tmp13_ = NULL;
				gchar** _tmp14_;
				gint _tmp14__length1;
				gchar* _tmp17_;
#line 83 "../src/Backend/RygelConfigFile.vala"
				_tmp14_ = self->priv->media_uris;
#line 83 "../src/Backend/RygelConfigFile.vala"
				_tmp14__length1 = self->priv->media_uris_length1;
#line 83 "../src/Backend/RygelConfigFile.vala"
				if (_tmp14__length1 > 2) {
#line 290 "RygelConfigFile.c"
					gchar** _tmp15_;
					gint _tmp15__length1;
					const gchar* _tmp16_;
#line 83 "../src/Backend/RygelConfigFile.vala"
					_tmp15_ = self->priv->media_uris;
#line 83 "../src/Backend/RygelConfigFile.vala"
					_tmp15__length1 = self->priv->media_uris_length1;
#line 83 "../src/Backend/RygelConfigFile.vala"
					_tmp16_ = _tmp15_[2];
#line 83 "../src/Backend/RygelConfigFile.vala"
					_tmp13_ = _tmp16_;
#line 302 "RygelConfigFile.c"
				} else {
#line 83 "../src/Backend/RygelConfigFile.vala"
					_tmp13_ = "";
#line 306 "RygelConfigFile.c"
				}
#line 83 "../src/Backend/RygelConfigFile.vala"
				_tmp17_ = g_strdup (_tmp13_);
#line 83 "../src/Backend/RygelConfigFile.vala"
				result = _tmp17_;
#line 83 "../src/Backend/RygelConfigFile.vala"
				return result;
#line 314 "RygelConfigFile.c"
			}
		}
	} else {
#line 72 "../src/Backend/RygelConfigFile.vala"
		switch (0) {
#line 320 "RygelConfigFile.c"
			default:
			{
				gchar* _tmp18_;
#line 87 "../src/Backend/RygelConfigFile.vala"
				_tmp18_ = g_strdup ("");
#line 87 "../src/Backend/RygelConfigFile.vala"
				result = _tmp18_;
#line 87 "../src/Backend/RygelConfigFile.vala"
				return result;
#line 330 "RygelConfigFile.c"
			}
		}
	}
}

void
sharing_backend_rygel_config_file_set_media_type_enabled (SharingBackendRygelConfigFile* self,
                                                          const gchar* media_type_id,
                                                          gboolean enable)
{
	GKeyFile* _tmp0_;
	GKeyFile* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 91 "../src/Backend/RygelConfigFile.vala"
	g_return_if_fail (self != NULL);
#line 91 "../src/Backend/RygelConfigFile.vala"
	g_return_if_fail (media_type_id != NULL);
#line 92 "../src/Backend/RygelConfigFile.vala"
	_tmp0_ = self->priv->config_file;
#line 92 "../src/Backend/RygelConfigFile.vala"
	if (_tmp0_ == NULL) {
#line 93 "../src/Backend/RygelConfigFile.vala"
		return;
#line 355 "RygelConfigFile.c"
	}
#line 96 "../src/Backend/RygelConfigFile.vala"
	_tmp1_ = self->priv->config_file;
#line 96 "../src/Backend/RygelConfigFile.vala"
	_tmp2_ = g_strdup_printf ("share-%s", media_type_id);
#line 96 "../src/Backend/RygelConfigFile.vala"
	_tmp3_ = _tmp2_;
#line 96 "../src/Backend/RygelConfigFile.vala"
	g_key_file_set_boolean (_tmp1_, "Tracker", _tmp3_, enable);
#line 96 "../src/Backend/RygelConfigFile.vala"
	_g_free0 (_tmp3_);
#line 367 "RygelConfigFile.c"
}

void
sharing_backend_rygel_config_file_set_media_type_folder (SharingBackendRygelConfigFile* self,
                                                         const gchar* media_type_id,
                                                         const gchar* folder_path)
{
	gchar* _tmp0_ = NULL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp6_ = NULL;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar** _tmp12_;
	GKeyFile* _tmp13_;
	GKeyFile* _tmp14_;
	gchar** _tmp15_;
	gint _tmp15__length1;
#line 99 "../src/Backend/RygelConfigFile.vala"
	g_return_if_fail (self != NULL);
#line 99 "../src/Backend/RygelConfigFile.vala"
	g_return_if_fail (media_type_id != NULL);
#line 99 "../src/Backend/RygelConfigFile.vala"
	g_return_if_fail (folder_path != NULL);
#line 101 "../src/Backend/RygelConfigFile.vala"
	if (g_strcmp0 (media_type_id, "music") == 0) {
#line 394 "RygelConfigFile.c"
		gchar* _tmp1_;
#line 101 "../src/Backend/RygelConfigFile.vala"
		_tmp1_ = g_strdup (folder_path);
#line 101 "../src/Backend/RygelConfigFile.vala"
		_g_free0 (_tmp0_);
#line 101 "../src/Backend/RygelConfigFile.vala"
		_tmp0_ = _tmp1_;
#line 402 "RygelConfigFile.c"
	} else {
		gchar* _tmp2_;
#line 101 "../src/Backend/RygelConfigFile.vala"
		_tmp2_ = sharing_backend_rygel_config_file_get_media_type_folder (self, "music");
#line 101 "../src/Backend/RygelConfigFile.vala"
		_g_free0 (_tmp0_);
#line 101 "../src/Backend/RygelConfigFile.vala"
		_tmp0_ = _tmp2_;
#line 411 "RygelConfigFile.c"
	}
#line 102 "../src/Backend/RygelConfigFile.vala"
	if (g_strcmp0 (media_type_id, "videos") == 0) {
#line 415 "RygelConfigFile.c"
		gchar* _tmp4_;
#line 102 "../src/Backend/RygelConfigFile.vala"
		_tmp4_ = g_strdup (folder_path);
#line 102 "../src/Backend/RygelConfigFile.vala"
		_g_free0 (_tmp3_);
#line 102 "../src/Backend/RygelConfigFile.vala"
		_tmp3_ = _tmp4_;
#line 423 "RygelConfigFile.c"
	} else {
		gchar* _tmp5_;
#line 102 "../src/Backend/RygelConfigFile.vala"
		_tmp5_ = sharing_backend_rygel_config_file_get_media_type_folder (self, "videos");
#line 102 "../src/Backend/RygelConfigFile.vala"
		_g_free0 (_tmp3_);
#line 102 "../src/Backend/RygelConfigFile.vala"
		_tmp3_ = _tmp5_;
#line 432 "RygelConfigFile.c"
	}
#line 103 "../src/Backend/RygelConfigFile.vala"
	if (g_strcmp0 (media_type_id, "pictures") == 0) {
#line 436 "RygelConfigFile.c"
		gchar* _tmp7_;
#line 103 "../src/Backend/RygelConfigFile.vala"
		_tmp7_ = g_strdup (folder_path);
#line 103 "../src/Backend/RygelConfigFile.vala"
		_g_free0 (_tmp6_);
#line 103 "../src/Backend/RygelConfigFile.vala"
		_tmp6_ = _tmp7_;
#line 444 "RygelConfigFile.c"
	} else {
		gchar* _tmp8_;
#line 103 "../src/Backend/RygelConfigFile.vala"
		_tmp8_ = sharing_backend_rygel_config_file_get_media_type_folder (self, "pictures");
#line 103 "../src/Backend/RygelConfigFile.vala"
		_g_free0 (_tmp6_);
#line 103 "../src/Backend/RygelConfigFile.vala"
		_tmp6_ = _tmp8_;
#line 453 "RygelConfigFile.c"
	}
#line 100 "../src/Backend/RygelConfigFile.vala"
	_tmp9_ = g_strdup (_tmp0_);
#line 100 "../src/Backend/RygelConfigFile.vala"
	_tmp10_ = g_strdup (_tmp3_);
#line 100 "../src/Backend/RygelConfigFile.vala"
	_tmp11_ = g_strdup (_tmp6_);
#line 100 "../src/Backend/RygelConfigFile.vala"
	_tmp12_ = g_new0 (gchar*, 3 + 1);
#line 100 "../src/Backend/RygelConfigFile.vala"
	_tmp12_[0] = _tmp9_;
#line 100 "../src/Backend/RygelConfigFile.vala"
	_tmp12_[1] = _tmp10_;
#line 100 "../src/Backend/RygelConfigFile.vala"
	_tmp12_[2] = _tmp11_;
#line 100 "../src/Backend/RygelConfigFile.vala"
	self->priv->media_uris = (_vala_array_free (self->priv->media_uris, self->priv->media_uris_length1, (GDestroyNotify) g_free), NULL);
#line 100 "../src/Backend/RygelConfigFile.vala"
	self->priv->media_uris = _tmp12_;
#line 100 "../src/Backend/RygelConfigFile.vala"
	self->priv->media_uris_length1 = 3;
#line 100 "../src/Backend/RygelConfigFile.vala"
	self->priv->_media_uris_size_ = self->priv->media_uris_length1;
#line 106 "../src/Backend/RygelConfigFile.vala"
	_tmp13_ = self->priv->config_file;
#line 106 "../src/Backend/RygelConfigFile.vala"
	if (_tmp13_ == NULL) {
#line 107 "../src/Backend/RygelConfigFile.vala"
		_g_free0 (_tmp6_);
#line 107 "../src/Backend/RygelConfigFile.vala"
		_g_free0 (_tmp3_);
#line 107 "../src/Backend/RygelConfigFile.vala"
		_g_free0 (_tmp0_);
#line 107 "../src/Backend/RygelConfigFile.vala"
		return;
#line 489 "RygelConfigFile.c"
	}
#line 110 "../src/Backend/RygelConfigFile.vala"
	_tmp14_ = self->priv->config_file;
#line 110 "../src/Backend/RygelConfigFile.vala"
	_tmp15_ = self->priv->media_uris;
#line 110 "../src/Backend/RygelConfigFile.vala"
	_tmp15__length1 = self->priv->media_uris_length1;
#line 110 "../src/Backend/RygelConfigFile.vala"
	g_key_file_set_string_list (_tmp14_, "MediaExport", "uris", (const gchar* const*) _tmp15_, (gint) _tmp15__length1);
#line 99 "../src/Backend/RygelConfigFile.vala"
	_g_free0 (_tmp6_);
#line 99 "../src/Backend/RygelConfigFile.vala"
	_g_free0 (_tmp3_);
#line 99 "../src/Backend/RygelConfigFile.vala"
	_g_free0 (_tmp0_);
#line 505 "RygelConfigFile.c"
}

gboolean
sharing_backend_rygel_config_file_save (SharingBackendRygelConfigFile* self)
{
	GKeyFile* _tmp0_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 113 "../src/Backend/RygelConfigFile.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 114 "../src/Backend/RygelConfigFile.vala"
	_tmp0_ = self->priv->config_file;
#line 114 "../src/Backend/RygelConfigFile.vala"
	if (_tmp0_ == NULL) {
#line 520 "RygelConfigFile.c"
		const gchar* _tmp1_;
#line 115 "../src/Backend/RygelConfigFile.vala"
		_tmp1_ = self->priv->config_filename;
#line 115 "../src/Backend/RygelConfigFile.vala"
		g_warning ("RygelConfigFile.vala:115: The loaded configuration file %s wasn't vali" \
"d. Saving isn't allowed to prevent overwriting a broken rygel.conf.", _tmp1_);
#line 117 "../src/Backend/RygelConfigFile.vala"
		result = FALSE;
#line 117 "../src/Backend/RygelConfigFile.vala"
		return result;
#line 530 "RygelConfigFile.c"
	}
	{
		GKeyFile* _tmp2_;
		const gchar* _tmp3_;
#line 121 "../src/Backend/RygelConfigFile.vala"
		_tmp2_ = self->priv->config_file;
#line 121 "../src/Backend/RygelConfigFile.vala"
		_tmp3_ = self->priv->config_filename;
#line 121 "../src/Backend/RygelConfigFile.vala"
		g_key_file_save_to_file (_tmp2_, _tmp3_, &_inner_error0_);
#line 121 "../src/Backend/RygelConfigFile.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 543 "RygelConfigFile.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp4_;
		GError* _tmp5_;
		const gchar* _tmp6_;
#line 120 "../src/Backend/RygelConfigFile.vala"
		e = _inner_error0_;
#line 120 "../src/Backend/RygelConfigFile.vala"
		_inner_error0_ = NULL;
#line 123 "../src/Backend/RygelConfigFile.vala"
		_tmp4_ = self->priv->config_filename;
#line 123 "../src/Backend/RygelConfigFile.vala"
		_tmp5_ = e;
#line 123 "../src/Backend/RygelConfigFile.vala"
		_tmp6_ = _tmp5_->message;
#line 123 "../src/Backend/RygelConfigFile.vala"
		g_warning ("RygelConfigFile.vala:123: Saving configuration file %s failed: %s", _tmp4_, _tmp6_);
#line 125 "../src/Backend/RygelConfigFile.vala"
		result = FALSE;
#line 125 "../src/Backend/RygelConfigFile.vala"
		_g_error_free0 (e);
#line 125 "../src/Backend/RygelConfigFile.vala"
		return result;
#line 572 "RygelConfigFile.c"
	}
	__finally0:
#line 120 "../src/Backend/RygelConfigFile.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 577 "RygelConfigFile.c"
		gboolean _tmp7_ = FALSE;
#line 120 "../src/Backend/RygelConfigFile.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 120 "../src/Backend/RygelConfigFile.vala"
		g_clear_error (&_inner_error0_);
#line 120 "../src/Backend/RygelConfigFile.vala"
		return _tmp7_;
#line 585 "RygelConfigFile.c"
	}
#line 128 "../src/Backend/RygelConfigFile.vala"
	result = TRUE;
#line 128 "../src/Backend/RygelConfigFile.vala"
	return result;
#line 591 "RygelConfigFile.c"
}

static void
sharing_backend_rygel_config_file_setup_config_file (SharingBackendRygelConfigFile* self)
{
	GKeyFile* _tmp0_;
	GKeyFile* _tmp1_;
	GKeyFile* _tmp2_;
	GKeyFile* _tmp3_;
	GKeyFile* _tmp4_;
	GKeyFile* _tmp5_;
	GKeyFile* _tmp6_;
	GKeyFile* _tmp7_;
	GKeyFile* _tmp8_;
	GKeyFile* _tmp9_;
	GKeyFile* _tmp10_;
	GKeyFile* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar** _tmp18_;
	gchar** _tmp19_;
	gint _tmp19__length1;
	GKeyFile* _tmp20_;
	GKeyFile* _tmp21_;
	GKeyFile* _tmp22_;
	GKeyFile* _tmp23_;
	GKeyFile* _tmp24_;
	GKeyFile* _tmp25_;
	GKeyFile* _tmp26_;
	GKeyFile* _tmp27_;
	GKeyFile* _tmp28_;
	GKeyFile* _tmp29_;
	gchar* _tmp30_;
	gchar* _tmp31_;
	gchar* _tmp32_;
	gchar** _tmp33_;
	gchar** _tmp34_;
	gint _tmp34__length1;
	GKeyFile* _tmp35_;
	GKeyFile* _tmp36_;
	GKeyFile* _tmp37_;
	GKeyFile* _tmp38_;
	GKeyFile* _tmp39_;
	GKeyFile* _tmp40_;
#line 131 "../src/Backend/RygelConfigFile.vala"
	g_return_if_fail (self != NULL);
#line 132 "../src/Backend/RygelConfigFile.vala"
	_tmp0_ = self->priv->config_file;
#line 132 "../src/Backend/RygelConfigFile.vala"
	g_key_file_set_boolean (_tmp0_, "general", "upnp-enabled", TRUE);
#line 133 "../src/Backend/RygelConfigFile.vala"
	_tmp1_ = self->priv->config_file;
#line 133 "../src/Backend/RygelConfigFile.vala"
	g_key_file_set_boolean (_tmp1_, "general", "enable-transcoding", TRUE);
#line 134 "../src/Backend/RygelConfigFile.vala"
	_tmp2_ = self->priv->config_file;
#line 134 "../src/Backend/RygelConfigFile.vala"
	g_key_file_set_string (_tmp2_, "general", "video-upload-folder", "@VIDEOS@");
#line 135 "../src/Backend/RygelConfigFile.vala"
	_tmp3_ = self->priv->config_file;
#line 135 "../src/Backend/RygelConfigFile.vala"
	g_key_file_set_string (_tmp3_, "general", "music-upload-folder", "@MUSIC@");
#line 136 "../src/Backend/RygelConfigFile.vala"
	_tmp4_ = self->priv->config_file;
#line 136 "../src/Backend/RygelConfigFile.vala"
	g_key_file_set_string (_tmp4_, "general", "picture-upload-folder", "@PICTURES@");
#line 137 "../src/Backend/RygelConfigFile.vala"
	_tmp5_ = self->priv->config_file;
#line 137 "../src/Backend/RygelConfigFile.vala"
	g_key_file_set_string (_tmp5_, "general", "media-engine", "librygel-media-engine-gst.so");
#line 138 "../src/Backend/RygelConfigFile.vala"
	_tmp6_ = self->priv->config_file;
#line 138 "../src/Backend/RygelConfigFile.vala"
	g_key_file_set_string (_tmp6_, "general", "interface", "");
#line 139 "../src/Backend/RygelConfigFile.vala"
	_tmp7_ = self->priv->config_file;
#line 139 "../src/Backend/RygelConfigFile.vala"
	g_key_file_set_integer (_tmp7_, "general", "port", 0);
#line 140 "../src/Backend/RygelConfigFile.vala"
	_tmp8_ = self->priv->config_file;
#line 140 "../src/Backend/RygelConfigFile.vala"
	g_key_file_set_string (_tmp8_, "general", "log-level", "*:4");
#line 141 "../src/Backend/RygelConfigFile.vala"
	_tmp9_ = self->priv->config_file;
#line 141 "../src/Backend/RygelConfigFile.vala"
	g_key_file_set_boolean (_tmp9_, "general", "allow-upload", TRUE);
#line 142 "../src/Backend/RygelConfigFile.vala"
	_tmp10_ = self->priv->config_file;
#line 142 "../src/Backend/RygelConfigFile.vala"
	g_key_file_set_boolean (_tmp10_, "general", "allow-deletion", TRUE);
#line 144 "../src/Backend/RygelConfigFile.vala"
	_tmp11_ = self->priv->config_file;
#line 144 "../src/Backend/RygelConfigFile.vala"
	_tmp12_ = g_strdup ("mp3");
#line 144 "../src/Backend/RygelConfigFile.vala"
	_tmp13_ = g_strdup ("lpcm");
#line 144 "../src/Backend/RygelConfigFile.vala"
	_tmp14_ = g_strdup ("mp2ts");
#line 144 "../src/Backend/RygelConfigFile.vala"
	_tmp15_ = g_strdup ("wmv");
#line 144 "../src/Backend/RygelConfigFile.vala"
	_tmp16_ = g_strdup ("aac");
#line 144 "../src/Backend/RygelConfigFile.vala"
	_tmp17_ = g_strdup ("avc");
#line 144 "../src/Backend/RygelConfigFile.vala"
	_tmp18_ = g_new0 (gchar*, 6 + 1);
#line 144 "../src/Backend/RygelConfigFile.vala"
	_tmp18_[0] = _tmp12_;
#line 144 "../src/Backend/RygelConfigFile.vala"
	_tmp18_[1] = _tmp13_;
#line 144 "../src/Backend/RygelConfigFile.vala"
	_tmp18_[2] = _tmp14_;
#line 144 "../src/Backend/RygelConfigFile.vala"
	_tmp18_[3] = _tmp15_;
#line 144 "../src/Backend/RygelConfigFile.vala"
	_tmp18_[4] = _tmp16_;
#line 144 "../src/Backend/RygelConfigFile.vala"
	_tmp18_[5] = _tmp17_;
#line 144 "../src/Backend/RygelConfigFile.vala"
	_tmp19_ = _tmp18_;
#line 144 "../src/Backend/RygelConfigFile.vala"
	_tmp19__length1 = 6;
#line 144 "../src/Backend/RygelConfigFile.vala"
	g_key_file_set_string_list (_tmp11_, "GstMediaEngine", "transcoders", (const gchar* const*) _tmp19_, (gint) 6);
#line 144 "../src/Backend/RygelConfigFile.vala"
	_tmp19_ = (_vala_array_free (_tmp19_, _tmp19__length1, (GDestroyNotify) g_free), NULL);
#line 146 "../src/Backend/RygelConfigFile.vala"
	_tmp20_ = self->priv->config_file;
#line 146 "../src/Backend/RygelConfigFile.vala"
	g_key_file_set_integer (_tmp20_, "Renderer", "image-timeout", 15);
#line 148 "../src/Backend/RygelConfigFile.vala"
	_tmp21_ = self->priv->config_file;
#line 148 "../src/Backend/RygelConfigFile.vala"
	g_key_file_set_boolean (_tmp21_, "Tracker", "enabled", TRUE);
#line 149 "../src/Backend/RygelConfigFile.vala"
	_tmp22_ = self->priv->config_file;
#line 149 "../src/Backend/RygelConfigFile.vala"
	g_key_file_set_boolean (_tmp22_, "Tracker", "share-pictures", TRUE);
#line 150 "../src/Backend/RygelConfigFile.vala"
	_tmp23_ = self->priv->config_file;
#line 150 "../src/Backend/RygelConfigFile.vala"
	g_key_file_set_boolean (_tmp23_, "Tracker", "share-videos", TRUE);
#line 151 "../src/Backend/RygelConfigFile.vala"
	_tmp24_ = self->priv->config_file;
#line 151 "../src/Backend/RygelConfigFile.vala"
	g_key_file_set_boolean (_tmp24_, "Tracker", "share-music", TRUE);
#line 152 "../src/Backend/RygelConfigFile.vala"
	_tmp25_ = self->priv->config_file;
#line 152 "../src/Backend/RygelConfigFile.vala"
	g_key_file_set_boolean (_tmp25_, "Tracker", "strict-sharing", FALSE);
#line 153 "../src/Backend/RygelConfigFile.vala"
	_tmp26_ = self->priv->config_file;
#line 153 "../src/Backend/RygelConfigFile.vala"
	g_key_file_set_string (_tmp26_, "Tracker", "title", "@HOSTNAME@: @REALNAME@");
#line 155 "../src/Backend/RygelConfigFile.vala"
	_tmp27_ = self->priv->config_file;
#line 155 "../src/Backend/RygelConfigFile.vala"
	g_key_file_set_boolean (_tmp27_, "MediaExport", "enabled", TRUE);
#line 156 "../src/Backend/RygelConfigFile.vala"
	_tmp28_ = self->priv->config_file;
#line 156 "../src/Backend/RygelConfigFile.vala"
	g_key_file_set_string (_tmp28_, "MediaExport", "title", "@HOSTNAME@: @REALNAME@");
#line 157 "../src/Backend/RygelConfigFile.vala"
	_tmp29_ = self->priv->config_file;
#line 157 "../src/Backend/RygelConfigFile.vala"
	_tmp30_ = g_strdup ("@MUSIC@");
#line 157 "../src/Backend/RygelConfigFile.vala"
	_tmp31_ = g_strdup ("@VIDEOS@");
#line 157 "../src/Backend/RygelConfigFile.vala"
	_tmp32_ = g_strdup ("@PICTURES@");
#line 157 "../src/Backend/RygelConfigFile.vala"
	_tmp33_ = g_new0 (gchar*, 3 + 1);
#line 157 "../src/Backend/RygelConfigFile.vala"
	_tmp33_[0] = _tmp30_;
#line 157 "../src/Backend/RygelConfigFile.vala"
	_tmp33_[1] = _tmp31_;
#line 157 "../src/Backend/RygelConfigFile.vala"
	_tmp33_[2] = _tmp32_;
#line 157 "../src/Backend/RygelConfigFile.vala"
	_tmp34_ = _tmp33_;
#line 157 "../src/Backend/RygelConfigFile.vala"
	_tmp34__length1 = 3;
#line 157 "../src/Backend/RygelConfigFile.vala"
	g_key_file_set_string_list (_tmp29_, "MediaExport", "uris", (const gchar* const*) _tmp34_, (gint) 3);
#line 157 "../src/Backend/RygelConfigFile.vala"
	_tmp34_ = (_vala_array_free (_tmp34_, _tmp34__length1, (GDestroyNotify) g_free), NULL);
#line 158 "../src/Backend/RygelConfigFile.vala"
	_tmp35_ = self->priv->config_file;
#line 158 "../src/Backend/RygelConfigFile.vala"
	g_key_file_set_boolean (_tmp35_, "MediaExport", "extract-metadata", TRUE);
#line 159 "../src/Backend/RygelConfigFile.vala"
	_tmp36_ = self->priv->config_file;
#line 159 "../src/Backend/RygelConfigFile.vala"
	g_key_file_set_boolean (_tmp36_, "MediaExport", "monitor-changes", TRUE);
#line 160 "../src/Backend/RygelConfigFile.vala"
	_tmp37_ = self->priv->config_file;
#line 160 "../src/Backend/RygelConfigFile.vala"
	g_key_file_set_integer (_tmp37_, "MediaExport", "monitor-grace-timeout", 5);
#line 161 "../src/Backend/RygelConfigFile.vala"
	_tmp38_ = self->priv->config_file;
#line 161 "../src/Backend/RygelConfigFile.vala"
	g_key_file_set_boolean (_tmp38_, "MediaExport", "virtual-folders", TRUE);
#line 163 "../src/Backend/RygelConfigFile.vala"
	_tmp39_ = self->priv->config_file;
#line 163 "../src/Backend/RygelConfigFile.vala"
	g_key_file_set_boolean (_tmp39_, "Playbin", "enabled", TRUE);
#line 164 "../src/Backend/RygelConfigFile.vala"
	_tmp40_ = self->priv->config_file;
#line 164 "../src/Backend/RygelConfigFile.vala"
	g_key_file_set_string (_tmp40_, "Playbin", "title", "Audio/Video playback on @HOSTNAME@");
#line 806 "RygelConfigFile.c"
}

SharingBackendRygelConfigFile*
sharing_backend_rygel_config_file_construct (GType object_type)
{
	SharingBackendRygelConfigFile * self = NULL;
#line 20 "../src/Backend/RygelConfigFile.vala"
	self = (SharingBackendRygelConfigFile*) g_object_new (object_type, NULL);
#line 20 "../src/Backend/RygelConfigFile.vala"
	return self;
#line 817 "RygelConfigFile.c"
}

SharingBackendRygelConfigFile*
sharing_backend_rygel_config_file_new (void)
{
#line 20 "../src/Backend/RygelConfigFile.vala"
	return sharing_backend_rygel_config_file_construct (SHARING_BACKEND_TYPE_RYGEL_CONFIG_FILE);
#line 825 "RygelConfigFile.c"
}

static GObject *
sharing_backend_rygel_config_file_constructor (GType type,
                                               guint n_construct_properties,
                                               GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	SharingBackendRygelConfigFile * self;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	GKeyFile* _tmp2_;
	const gchar* _tmp3_;
	GFile* _tmp4_;
	GFile* _tmp5_;
	gboolean _tmp6_;
	GError* _inner_error0_ = NULL;
#line 26 "../src/Backend/RygelConfigFile.vala"
	parent_class = G_OBJECT_CLASS (sharing_backend_rygel_config_file_parent_class);
#line 26 "../src/Backend/RygelConfigFile.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 26 "../src/Backend/RygelConfigFile.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SHARING_BACKEND_TYPE_RYGEL_CONFIG_FILE, SharingBackendRygelConfigFile);
#line 27 "../src/Backend/RygelConfigFile.vala"
	_tmp0_ = g_get_user_config_dir ();
#line 27 "../src/Backend/RygelConfigFile.vala"
	_tmp1_ = g_build_filename (_tmp0_, "rygel.conf", NULL);
#line 27 "../src/Backend/RygelConfigFile.vala"
	_g_free0 (self->priv->config_filename);
#line 27 "../src/Backend/RygelConfigFile.vala"
	self->priv->config_filename = _tmp1_;
#line 28 "../src/Backend/RygelConfigFile.vala"
	_tmp2_ = g_key_file_new ();
#line 28 "../src/Backend/RygelConfigFile.vala"
	_g_key_file_unref0 (self->priv->config_file);
#line 28 "../src/Backend/RygelConfigFile.vala"
	self->priv->config_file = _tmp2_;
#line 30 "../src/Backend/RygelConfigFile.vala"
	_tmp3_ = self->priv->config_filename;
#line 30 "../src/Backend/RygelConfigFile.vala"
	_tmp4_ = g_file_new_for_path (_tmp3_);
#line 30 "../src/Backend/RygelConfigFile.vala"
	_tmp5_ = _tmp4_;
#line 30 "../src/Backend/RygelConfigFile.vala"
	_tmp6_ = g_file_query_exists (_tmp5_, NULL);
#line 30 "../src/Backend/RygelConfigFile.vala"
	_g_object_unref0 (_tmp5_);
#line 30 "../src/Backend/RygelConfigFile.vala"
	if (_tmp6_) {
#line 876 "RygelConfigFile.c"
		{
			GKeyFile* _tmp7_;
			const gchar* _tmp8_;
#line 32 "../src/Backend/RygelConfigFile.vala"
			_tmp7_ = self->priv->config_file;
#line 32 "../src/Backend/RygelConfigFile.vala"
			_tmp8_ = self->priv->config_filename;
#line 32 "../src/Backend/RygelConfigFile.vala"
			g_key_file_load_from_file (_tmp7_, _tmp8_, G_KEY_FILE_KEEP_COMMENTS | G_KEY_FILE_KEEP_TRANSLATIONS, &_inner_error0_);
#line 32 "../src/Backend/RygelConfigFile.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 888 "RygelConfigFile.c"
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			const gchar* _tmp9_;
			GError* _tmp10_;
			const gchar* _tmp11_;
#line 31 "../src/Backend/RygelConfigFile.vala"
			e = _inner_error0_;
#line 31 "../src/Backend/RygelConfigFile.vala"
			_inner_error0_ = NULL;
#line 34 "../src/Backend/RygelConfigFile.vala"
			_tmp9_ = self->priv->config_filename;
#line 34 "../src/Backend/RygelConfigFile.vala"
			_tmp10_ = e;
#line 34 "../src/Backend/RygelConfigFile.vala"
			_tmp11_ = _tmp10_->message;
#line 34 "../src/Backend/RygelConfigFile.vala"
			g_warning ("RygelConfigFile.vala:34: Loading configuration file %s failed: %s", _tmp9_, _tmp11_);
#line 36 "../src/Backend/RygelConfigFile.vala"
			_g_key_file_unref0 (self->priv->config_file);
#line 36 "../src/Backend/RygelConfigFile.vala"
			self->priv->config_file = NULL;
#line 38 "../src/Backend/RygelConfigFile.vala"
			_g_error_free0 (e);
#line 38 "../src/Backend/RygelConfigFile.vala"
			return obj;
#line 919 "RygelConfigFile.c"
		}
		__finally0:
#line 31 "../src/Backend/RygelConfigFile.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 31 "../src/Backend/RygelConfigFile.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 31 "../src/Backend/RygelConfigFile.vala"
			g_clear_error (&_inner_error0_);
#line 928 "RygelConfigFile.c"
		}
	} else {
#line 41 "../src/Backend/RygelConfigFile.vala"
		g_debug ("RygelConfigFile.vala:41: Setting up new rygel.conf…");
#line 43 "../src/Backend/RygelConfigFile.vala"
		sharing_backend_rygel_config_file_setup_config_file (self);
#line 935 "RygelConfigFile.c"
	}
	{
		gchar** _tmp12_ = NULL;
		GKeyFile* _tmp13_;
		gsize _tmp14_ = 0;
		gchar** _tmp15_;
		gint _tmp12__length1;
		gint __tmp12__size_;
		gchar** _tmp16_;
		gint _tmp16__length1;
#line 47 "../src/Backend/RygelConfigFile.vala"
		_tmp13_ = self->priv->config_file;
#line 47 "../src/Backend/RygelConfigFile.vala"
		_tmp15_ = g_key_file_get_string_list (_tmp13_, "MediaExport", "uris", &_tmp14_, &_inner_error0_);
#line 47 "../src/Backend/RygelConfigFile.vala"
		_tmp12_ = _tmp15_;
#line 47 "../src/Backend/RygelConfigFile.vala"
		_tmp12__length1 = _tmp14_;
#line 47 "../src/Backend/RygelConfigFile.vala"
		__tmp12__size_ = _tmp12__length1;
#line 47 "../src/Backend/RygelConfigFile.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 958 "RygelConfigFile.c"
			goto __catch1_g_error;
		}
#line 47 "../src/Backend/RygelConfigFile.vala"
		_tmp16_ = _tmp12_;
#line 47 "../src/Backend/RygelConfigFile.vala"
		_tmp16__length1 = _tmp12__length1;
#line 47 "../src/Backend/RygelConfigFile.vala"
		_tmp12_ = NULL;
#line 47 "../src/Backend/RygelConfigFile.vala"
		_tmp12__length1 = 0;
#line 47 "../src/Backend/RygelConfigFile.vala"
		self->priv->media_uris = (_vala_array_free (self->priv->media_uris, self->priv->media_uris_length1, (GDestroyNotify) g_free), NULL);
#line 47 "../src/Backend/RygelConfigFile.vala"
		self->priv->media_uris = _tmp16_;
#line 47 "../src/Backend/RygelConfigFile.vala"
		self->priv->media_uris_length1 = _tmp16__length1;
#line 47 "../src/Backend/RygelConfigFile.vala"
		self->priv->_media_uris_size_ = self->priv->media_uris_length1;
#line 46 "../src/Backend/RygelConfigFile.vala"
		_tmp12_ = (_vala_array_free (_tmp12_, _tmp12__length1, (GDestroyNotify) g_free), NULL);
#line 979 "RygelConfigFile.c"
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp17_;
		GError* _tmp18_;
		const gchar* _tmp19_;
#line 46 "../src/Backend/RygelConfigFile.vala"
		e = _inner_error0_;
#line 46 "../src/Backend/RygelConfigFile.vala"
		_inner_error0_ = NULL;
#line 49 "../src/Backend/RygelConfigFile.vala"
		_tmp17_ = self->priv->config_filename;
#line 49 "../src/Backend/RygelConfigFile.vala"
		_tmp18_ = e;
#line 49 "../src/Backend/RygelConfigFile.vala"
		_tmp19_ = _tmp18_->message;
#line 49 "../src/Backend/RygelConfigFile.vala"
		g_warning ("RygelConfigFile.vala:49: Reading configuration file %s failed: %s", _tmp17_, _tmp19_);
#line 51 "../src/Backend/RygelConfigFile.vala"
		_g_key_file_unref0 (self->priv->config_file);
#line 51 "../src/Backend/RygelConfigFile.vala"
		self->priv->config_file = NULL;
#line 53 "../src/Backend/RygelConfigFile.vala"
		_g_error_free0 (e);
#line 53 "../src/Backend/RygelConfigFile.vala"
		return obj;
#line 1008 "RygelConfigFile.c"
	}
	__finally1:
#line 46 "../src/Backend/RygelConfigFile.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 46 "../src/Backend/RygelConfigFile.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 46 "../src/Backend/RygelConfigFile.vala"
		g_clear_error (&_inner_error0_);
#line 1017 "RygelConfigFile.c"
	}
#line 26 "../src/Backend/RygelConfigFile.vala"
	return obj;
#line 1021 "RygelConfigFile.c"
}

static void
sharing_backend_rygel_config_file_class_init (SharingBackendRygelConfigFileClass * klass,
                                              gpointer klass_data)
{
#line 20 "../src/Backend/RygelConfigFile.vala"
	sharing_backend_rygel_config_file_parent_class = g_type_class_peek_parent (klass);
#line 20 "../src/Backend/RygelConfigFile.vala"
	g_type_class_adjust_private_offset (klass, &SharingBackendRygelConfigFile_private_offset);
#line 20 "../src/Backend/RygelConfigFile.vala"
	G_OBJECT_CLASS (klass)->constructor = sharing_backend_rygel_config_file_constructor;
#line 20 "../src/Backend/RygelConfigFile.vala"
	G_OBJECT_CLASS (klass)->finalize = sharing_backend_rygel_config_file_finalize;
#line 1036 "RygelConfigFile.c"
}

static void
sharing_backend_rygel_config_file_instance_init (SharingBackendRygelConfigFile * self,
                                                 gpointer klass)
{
#line 20 "../src/Backend/RygelConfigFile.vala"
	self->priv = sharing_backend_rygel_config_file_get_instance_private (self);
#line 22 "../src/Backend/RygelConfigFile.vala"
	self->priv->config_file = NULL;
#line 1047 "RygelConfigFile.c"
}

static void
sharing_backend_rygel_config_file_finalize (GObject * obj)
{
	SharingBackendRygelConfigFile * self;
#line 20 "../src/Backend/RygelConfigFile.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SHARING_BACKEND_TYPE_RYGEL_CONFIG_FILE, SharingBackendRygelConfigFile);
#line 21 "../src/Backend/RygelConfigFile.vala"
	_g_free0 (self->priv->config_filename);
#line 22 "../src/Backend/RygelConfigFile.vala"
	_g_key_file_unref0 (self->priv->config_file);
#line 24 "../src/Backend/RygelConfigFile.vala"
	self->priv->media_uris = (_vala_array_free (self->priv->media_uris, self->priv->media_uris_length1, (GDestroyNotify) g_free), NULL);
#line 20 "../src/Backend/RygelConfigFile.vala"
	G_OBJECT_CLASS (sharing_backend_rygel_config_file_parent_class)->finalize (obj);
#line 1064 "RygelConfigFile.c"
}

static GType
sharing_backend_rygel_config_file_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SharingBackendRygelConfigFileClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sharing_backend_rygel_config_file_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SharingBackendRygelConfigFile), 0, (GInstanceInitFunc) sharing_backend_rygel_config_file_instance_init, NULL };
	GType sharing_backend_rygel_config_file_type_id;
	sharing_backend_rygel_config_file_type_id = g_type_register_static (G_TYPE_OBJECT, "SharingBackendRygelConfigFile", &g_define_type_info, 0);
	SharingBackendRygelConfigFile_private_offset = g_type_add_instance_private (sharing_backend_rygel_config_file_type_id, sizeof (SharingBackendRygelConfigFilePrivate));
	return sharing_backend_rygel_config_file_type_id;
}

GType
sharing_backend_rygel_config_file_get_type (void)
{
	static volatile gsize sharing_backend_rygel_config_file_type_id__once = 0;
	if (g_once_init_enter (&sharing_backend_rygel_config_file_type_id__once)) {
		GType sharing_backend_rygel_config_file_type_id;
		sharing_backend_rygel_config_file_type_id = sharing_backend_rygel_config_file_get_type_once ();
		g_once_init_leave (&sharing_backend_rygel_config_file_type_id__once, sharing_backend_rygel_config_file_type_id);
	}
	return sharing_backend_rygel_config_file_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

